import java.io.*;
import java.util.*;

public class Main {
    public static class MyAnagramGame implements AnagramGame
    {
        // wordlists
        public String[] wordlist = {};

        // hiscore
        ArrayList<Integer> hiscore_scores;
        ArrayList<String> hiscore_words;

        // base word to check against
        public String baseword;

        // score
        public int score;

        public String setCharInPosition(int position, char ch, String str) {
            char[] charArray = str.toCharArray();
            charArray[position] = ch;
            return new String(charArray);
        }

        public int getScoreForWord(String needle, String haystack)
        {
            int char_counter = 0;
            int sc = 0;

            while (char_counter < needle.length())
            {
                char chara = needle.charAt(char_counter);

                if (haystack.indexOf(chara) != -1)
                {
                    sc++;
                    setCharInPosition(char_counter, ' ', haystack);
                }
                char_counter++;
            }
            return sc;
        }

        public void submitWord(String word)
        {
            System.out.println("base word: " + baseword);

            boolean valid = false;

            for (int i = 0; i < wordlist.length; i++)
            {
                if (word.equals(wordlist[i])) valid = true;
            }

            score = 0;

            if (valid)
            {
                score = getScoreForWord(word, baseword);
                System.out.println("score for word is " + score);

                for (int i = 0; i < 10; i++)
                {
                    if (score > hiscore_scores.get(i))
                    {
                        hiscore_scores.add(i,score);
                        hiscore_words.add(i,word);
                        break;
                    }
                    else if (score == hiscore_scores.get(i))
                    {
                        hiscore_scores.add(i+1,score);
                        hiscore_words.add(i+1,word);
                        break;
                    }
                }
            }
            else
            {
                System.out.println("Word not found in the word list");
            }
        }
        public String getWordEntryAtPosition(int position)
        {
            return hiscore_words.get(position);
        }
        public Integer getScoreAtPosition(int position)
        {
            return hiscore_scores.get(position);
        }

        public String[] readLines(String filename) throws IOException {
            FileReader fileReader = new FileReader(filename);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            List<String> lines = new ArrayList<String>();
            String line = null;

            while ((line = bufferedReader.readLine()) != null) {
                lines.add(line);
            }

            bufferedReader.close();
            return lines.toArray(new String[lines.size()]);
        }

        public String reverseString(String s) {
            return new StringBuffer(s).reverse().toString();
        }

        public String generateBaseword()
        {
            String randomString;
            Random random = new Random();
            char[] word = new char[random.nextInt(10)+20];
            for(int j = 0; j < word.length; j++)
            {
                word[j] = (char)('a' + random.nextInt(26));
            }
            randomString = new String(word);
            return randomString;
        }

        public MyAnagramGame() {
            hiscore_scores = new ArrayList<Integer>();
            hiscore_words = new ArrayList<String>();

            for (int i = 0; i < 10; i++)
            {
                hiscore_scores.add(0);
                hiscore_words.add("");
            }

            // init wordlists
            try
            {
                wordlist = readLines("wordlist.txt");
            }
            catch (IOException e)
            {
                System.out.println("Error reading the wordlist file!");
            }

            // generate baseword
            baseword = generateBaseword();
            //baseword = "areallylongword";
        }
    }

    public static void main(String[] args)
    {
        // game on
        MyAnagramGame game = new MyAnagramGame();
        game.submitWord("woolly");
    }
}
